From cf2ad4387f4c57d09d8617ba6b4abb95d4d4791d Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:11 +0000
Subject: [PATCH 742/1001] Allow the widget to declare where the views and cached functions are


---

diff --git a/hubs/tests/test_widget_base.py b/hubs/tests/test_widget_base.py
index 0abe27c..9b53e57 100644
--- a/hubs/tests/test_widget_base.py
+++ b/hubs/tests/test_widget_base.py
@@ -1,5 +1,7 @@
 from __future__ import unicode_literals
 
+import six
+
 from hubs.widgets.base import Widget
 from hubs.widgets.caching import CachedFunction
 from hubs.widgets.view import WidgetView
@@ -72,6 +74,20 @@ class WidgetTest(APPTest):
             {"root": TestingView}
             )
 
+    def test_list_views_relative(self):
+        testing_widget = TestingWidget()
+        testing_widget.views_module = ".nowhere"
+        self.assertRaises(AttributeError, testing_widget.get_views)
+        if six.PY2:
+            # On Python2, setting the import module to "." raises a KeyError,
+            # so we can't test.
+            return
+        testing_widget.views_module = "."
+        self.assertEqual(
+            testing_widget.get_views(),
+            {"root": TestingView}
+            )
+
     def test_list_functions(self):
         testing_widget = TestingWidget()
         self.assertEqual(
@@ -79,6 +95,20 @@ class WidgetTest(APPTest):
             {"TestingFunction": TestingFunction}
             )
 
+    def test_list_functions_relative(self):
+        testing_widget = TestingWidget()
+        testing_widget.cached_functions_module = ".nowhere"
+        self.assertRaises(AttributeError, testing_widget.get_cached_functions)
+        if six.PY2:
+            # On Python2, setting the import module to "." raises a KeyError,
+            # so we can't test.
+            return
+        testing_widget.cached_functions_module = "."
+        self.assertEqual(
+            testing_widget.get_cached_functions(),
+            {"TestingFunction": TestingFunction}
+            )
+
     def test_list_views(self):
         class TestView1(WidgetView):
             name = "root"
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index c6b87af..3d27813 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -55,11 +55,19 @@ class Widget(object):
             ``both``.
         parameters (list): A list of dictionaries that describe a widget's
             configuration. See :py:class:`hubs.widgets.base.WidgetParameter`.
+        views_module (list): The Python path to the module where the widget
+            views must be looked for.  By default, they are looked for in the
+            same module.
+        cached_functions_module (list): The Python path to the module where the
+            cached functions must be looked for.  By default, they are looked
+            for in the same module.
     """
 
     name = None
     position = None
     parameters = []
+    views_module = None
+    cached_functions_module = None
 
     def __init__(self):
         self._template_environment = None
@@ -120,20 +128,27 @@ class Widget(object):
             self._template_environment = env
         return self._template_environment
 
-    def _get_local_subclasses(self, parent_class):
+    def _get_local_subclasses(self, parent_class, module=None):
         """
         Returns the subclasses of the ``parent_class`` defined in this widget's
         Python module.
         """
+        if module is None:
+            module = self.__module__
         result = []
-        widget_module = import_module(self.__module__)
+        try:
+            widget_module = import_module(module, package=self.__module__)
+        except ImportError as e:
+            raise AttributeError(
+                "Could not find subclasses of %s in %s: %s"
+                % (parent_class, module, e))
         for objname in dir(widget_module):
             obj = getattr(widget_module, objname)
             if type(obj) != type(object):
                 continue  # we only look for classes
             if not issubclass(obj, parent_class):
                 continue  # we only want subclasses of the parent_class
-            if obj.__module__ != self.__module__:
+            if obj.__module__ != widget_module.__name__:
                 # we don't want locally imported classes (like the
                 # parent_class itself)
                 continue
@@ -148,7 +163,7 @@ class Widget(object):
         """
         return dict([
             (view.name, view) for view in
-            self._get_local_subclasses(WidgetView)
+            self._get_local_subclasses(WidgetView, self.views_module)
             ])
 
     def register_routes(self, app):
@@ -180,6 +195,7 @@ class Widget(object):
                 their class name.
         """
         result = {}
-        for fn_class in self._get_local_subclasses(CachedFunction):
+        for fn_class in self._get_local_subclasses(
+                CachedFunction, self.cached_functions_module):
             result[fn_class.__name__] = fn_class
         return result

